
hirom
header

org $C1115D
JSL new_LZ  ; call the optimized decompression routine instead

org $C11C9B
JSL new_LZ  ; call the optimized decompression routine instead

org $C11D5B
JSL new_LZ  ; call the optimized decompression routine instead

org $C16D1E  ; location in v1.0
;org $C16D1B  ; location in v1.1 - this is the only difference for v1.1
JSL new_LZ  ; call the optimized decompression routine instead

org $C2685E
JSL new_LZ  ; call the optimized decompression routine instead

org $C27DBA
DB new_LZ
DB $EB  ; this is used during LZ decompression, do not change this
DW new_LZ>>8

;org $C27D88  ; this is if you are using Yazoo's title screen patch
;DL new_LZ  ; this is if you are using Yazoo's title screen patch

org $C288CD
DW new_LZ
DB $F5  ; this is used during LZ decompression, do not change this
DB new_LZ>>16

;org $C288A2  ; this is if you are using Yazoo's title screen patch
;DB $D7  ; this is if you are using Yazoo's title screen patch
;DL new_LZ  ; this is if you are using Yazoo's title screen patch

org $C2B568
JSL new_LZ  ; call the optimized decompression routine instead

org $C2EC75
JSL new_LZ  ; call the optimized decompression routine instead

org $C2ECA8
JSL new_LZ  ; call the optimized decompression routine instead

org $C3B400
JSL new_LZ  ; call the optimized decompression routine instead

org $C3DD6E
JSL new_LZ  ; call the optimized decompression routine instead

org $C0046C
; this is an attempt to speed up the LZSS decompression routine, just like EE!
; some comments are curteousy of MathOnNapkins, some from Novalia Spirit
new_LZ:
PHB    ; preserve bank
PHD    ; preserve DP register
LDX #$0000   ; this is 1 cycle faster than LDX $00, if space is needed change this to LDX $00 or TDC TAX
PHX
PLD    ; set DP register to #$0000
REP #$20
LDA [$F3]  ; size of compressed data
STA $FC
LDA $F6    ; destination
STA $002181  ; save as WRAM address
SEP #$20
LDA $F8    ; destination bank
AND #$01   ; keep first bit only, 7E becomes 00, 7F becomes 01
STA $002183  ; save as WRAM bank
LDA #$01
STA $FE
LDY #$0002
LDA #$7F
PHA
PLB   ; set bank to #$7F
JSR speedy  ; zero out ram at 7F/F800,X - this is 60% faster than the original loop
LDX #$FFDE
A4AB:
DEC $FE
BNE A4B8
LDA #$08
STA $FE
LDA [$F3],Y  ; grab a byte from the buffer
STA $FF   ; and save for now
INY   ; next byte in the buffer
A4B8:
LSR $FF
BCC A4CD
LDA [$F3],Y  ; next byte in the buffer
STA $002180  ; to WRAM!
STA $0000,X  ; to 7F/F800,X
INX
BNE A4FF
LDX #$F800   ; starting position again
BRA A4FF
A4CD:
LDA [$F3],Y  ; next byte in the buffer
XBA
INY
STY $F9
LDA [$F3],Y  ; next byte in the buffer
LSR #3
CLC
ADC #$03
STA $FB
LDA [$F3],Y  ; same byte as previous load in the buffer
ORA #$F8   ; set bits 3-7, this will become an address
XBA   ; move address to high byte
TAY
A4E3:
LDA $0000,Y
STA $002180  ; to WRAM!
STA $0000,X
INX
BNE A4F3
LDX #$F800   ; starting position again
A4F3:
INY
BNE A4F9
LDY #$F800   ; starting position again
A4F9:
DEC $FB
BNE A4E3
LDY $F9
A4FF:
INY
CPY $FC   ; have we run out of bytes to copy or exceeded the buffer?
BNE A4AB  ; branch if not
TDC  ; pointless XBA after this, A = #$0000
PLD  ; restore DP register
PLB  ; restore bank
RTL  ; done!

padbyte $FF : pad $C004F8

; one whole byte free!

org $C0DF2F

speedy:
; unroll the loop to zero out some ram, this is as fast as it can get without diminishing returns
LDX #$F800  ; 3 cycles
REP #$21  ; 3 cycles, clear carry just this one time since the ADC will never set it until the loop is set to break
again:
STZ $0000,X  ; 6 cycles per iteration
STZ $0002,X  ; 6 cycles per iteration
STZ $0004,X  ; 6 cycles per iteration
STZ $0006,X  ; 6 cycles per iteration
STZ $0008,X  ; 6 cycles per iteration
STZ $000A,X  ; 6 cycles per iteration
STZ $000C,X  ; 6 cycles per iteration
STZ $000E,X  ; 6 cycles per iteration
STZ $0010,X  ; 6 cycles per iteration
STZ $0012,X  ; 6 cycles per iteration
STZ $0014,X  ; 6 cycles per iteration
STZ $0016,X  ; 6 cycles per iteration
STZ $0018,X  ; 6 cycles per iteration
STZ $001A,X  ; 6 cycles per iteration
STZ $001C,X  ; 6 cycles per iteration
STZ $001E,X  ; 6 cycles per iteration
STZ $0020,X  ; 6 cycles per iteration
STZ $0022,X  ; 6 cycles per iteration
STZ $0024,X  ; 6 cycles per iteration
STZ $0026,X  ; 6 cycles per iteration
STZ $0028,X  ; 6 cycles per iteration
STZ $002A,X  ; 6 cycles per iteration
STZ $002C,X  ; 6 cycles per iteration
STZ $002E,X  ; 6 cycles per iteration
STZ $0030,X  ; 6 cycles per iteration
STZ $0032,X  ; 6 cycles per iteration
STZ $0034,X  ; 6 cycles per iteration
STZ $0036,X  ; 6 cycles per iteration
STZ $0038,X  ; 6 cycles per iteration
STZ $003A,X  ; 6 cycles per iteration
STZ $003C,X  ; 6 cycles per iteration
STZ $003E,X  ; 6 cycles per iteration
TXA  ; 2 cycles
ADC #$0040  ; 3 cycles
BEQ done  ; 2 cycles for 31 iterations, 3 on last
TAX  ; 2 cycles
BRA again  ; 3 cycles
done:
SEP #$20  ; 3 cycles
RTS  ; 6 cycles

org $C2FF6D
padbyte $FF : pad $C30000  ; comment this out if you don't want erase anything here
